IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[PMX_SP_IMP_GoodsReceiptLabel]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[PMX_SP_IMP_GoodsReceiptLabel]
GO

-- =============================================
-- Author:		Produmex
-- Create date: 
-- Description:	Impermo goods receipt label
-- =============================================
CREATE PROCEDURE [dbo].[PMX_SP_IMP_GoodsReceiptLabel] 
	-- Parameters for the stored procedure
	@luid int = 0,
	@sscc nvarchar (18),
	@itemCode nvarchar (20),
	@quantity numeric (19,6),
	@bestBeforeDate nvarchar(30),
	@batchNumber nvarchar (32),
	@purchaseOrderDocEntry int,
	@cardCode nvarchar (15),
	@InternalLuid int = 0
	

AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	--Declare return variables
	DECLARE @returnSSCC [nvarchar](18)
	DECLARE @returnGTIN AS [nvarchar] (16) 
	DECLARE @returnLogisticCarrierCode AS [nvarchar] (20)  
	DECLARE @returnItemCode AS [nvarchar](20) 
	DECLARE @returnProductDescription AS [nvarchar](100) 
	DECLARE @returnQuantity AS [numeric](19,0) 
	DECLARE @returnIsLogisticUnit AS [nvarchar](1) 
	DECLARE @returnBatchNumber AS [nvarchar](32) 
	DECLARE @returnBestBeforeDate AS [datetime]
	DECLARE @returnSSCCBarcode AS [nvarchar] (100)
	DECLARE @returnSSCCBarcodeDigit AS [nvarchar] (100)
	DECLARE @returnGTINBarcode AS [nvarchar] (200)
	DECLARE @returnGTINBarcodeDigit AS [nvarchar] (200)
 	DECLARE @returnBarcodeType AS [nvarchar] (1)
	DECLARE @returnBatchBarcode AS [nvarchar] (100)
	DECLARE @returnBatchBarcodeDigit AS [nvarchar] (100)
	DECLARE @returnGTINLabel AS [nvarchar] (20)
	DECLARE @returnImpCode AS [varchar](30)
	DECLARE @returnPackagingType AS [nvarchar] (8)
	DECLARE @returnQtyPerPackagingType AS [numeric](19,6)


	--Getting the PO info
	--Declare variables for the cursor
	DECLARE @PONumber AS [int]
	DECLARE @SupplierName AS [nvarchar] (100) 
	DECLARE @SupplierAddress AS [nvarchar] (254)  
	DECLARE @ReceptionDate AS [datetime] 
	DECLARE @CustomerCode AS [nvarchar](100)
	DECLARE @SONumber AS [int]

	--Declare variables for product
	DECLARE @GTIN AS [nvarchar] (16) 
	DECLARE @LogisticCarrierCode AS [nvarchar] (20)  
	DECLARE @ProductDescription AS [nvarchar](100) 
	DECLARE @IsLogisticCarrier AS [nvarchar](1) 
	DECLARE @BarcodeType AS [nvarchar] (1)
	DECLARE @ImpCode AS [varchar] (30)
	DECLARE @PackagingType AS [nvarchar] (8)
	DECLARE @QtyPerPackagingType AS [numeric](19,6)
	
	
	--test
	
	DECLARE @test AS numeric (19,6)




	IF(@luid <> 0) 
	
	BEGIN
	
	
		--Declare memory table for storing the products on an sscc
		DECLARE @productsTable TABLE (
			[SSCC] [nvarchar] (18) NOT NULL ,
			[GTIN] [nvarchar] (16) NULL ,
			[LogisticCarrierCode] [nvarchar] (20) NULL ,
			[ItemCode] [nvarchar](20) NULL ,
			[ProductDescription] [nvarchar](100) NULL,
			[Quantity] [numeric](19,6) NULL,
			[IsLogisticCarrier] [nvarchar](1) NULL,
			[BatchNumber] [nvarchar](32) NULL,
			[BestBeforeDate] [datetime] NULL,
			[BarcodeType] [nvarchar](1) NULL,
			[ImpCode] [nvarchar] (30) NULL,
			[PackagingType] [nvarchar] (8) NULL,
			[QtyPerPackagingType] [numeric] (19,6)
			
		)

		-- Insert the products into an in memory table
		INSERT into @productsTable
			SELECT SSCC, Barcode, LogisticCarrierCode, PMX_IMP_SSCC_GOODSRECEIPT_LABEL.ItemCode, ISNULL(ProductDescription, PMX_IMP_SSCC_GOODSRECEIPT_LABEL.ItemCode) AS ProductDescription, Quantity , IsLogisticCarrier, BatchNumber, BestBeforeDate, ISNULL(U_PMX_BCTY,'G') AS BarcodeType, OITM.U_OrgArt As ImpCode,
			dbo.PMX_IMP_SSCC_GOODSRECEIPT_LABEL.PackagingTypeCode as  PackagingType, dbo.PMX_IMP_SSCC_GOODSRECEIPT_LABEL.QtyPerPackagingType AS QtyPerPackagingType
			FROM dbo.PMX_IMP_SSCC_GOODSRECEIPT_LABEL INNER JOIN dbo.OITM ON dbo.OITM.ItemCode = dbo.PMX_IMP_SSCC_GOODSRECEIPT_LABEL.ItemCode
			WHERE LogUnitIdentKey = @luid
			ORDER BY IsLogisticCarrier, ItemCode

		--Loop tru all the lines
		DECLARE productsCursor CURSOR FOR SELECT SSCC, GTIN, LogisticCarrierCode, ItemCode, ProductDescription, Quantity , IsLogisticCarrier, BatchNumber, BestBeforeDate, BarcodeType,  PackagingType,QtyPerPackagingType  FROM @productsTable
		OPEN productsCursor
		FETCH NEXT FROM productsCursor INTO @SSCC, @GTIN, @LogisticCarrierCode, @ItemCode, @ProductDescription, @Quantity , @IsLogisticCarrier, @BatchNumber, @BestBeforeDate, @BarcodeType, @PackagingType,@QtyPerPackagingType
		
		
		IF(@@FETCH_STATUS >= 0)
		BEGIN
			SET @returnSSCC = @SSCC
			SET @returnGTIN = @GTIN
			SET @returnLogisticCarrierCode = @LogisticCarrierCode
			SET @returnItemCode = @ItemCode
			SET @returnProductDescription = @ProductDescription
			SET @returnQuantity = @Quantity
			SET @returnIsLogisticUnit = @IsLogisticCarrier
			SET @returnBatchNumber = @BatchNumber
			SET @returnBestBeforeDate = @BestBeforeDate
			SET @returnBarcodeType = @BarcodeType
			SET @returnImpCode = @ImpCode
			SET @returnPackagingType = @PackagingType
			SET @returnQtyPerPackagingType = @QtyPerPackagingType

			FETCH NEXT FROM productsCursor INTO @SSCC, @GTIN, @LogisticCarrierCode, @ItemCode, @ProductDescription, @Quantity , @IsLogisticCarrier, @BatchNumber, @BestBeforeDate, @BarcodeType, @PackagingType,@QtyPerPackagingType
		END
		WHILE @@FETCH_STATUS >= 0 BEGIN
			
			--Only when the previous product is the same as product, 
			--or if the current product is a logistic carrier and the quantity of the logistic carrier is 1, we can keep the product description, count and gtin.
			--In all other cases, we need to remove the product and count
			IF(@returnItemCode = @ItemCode OR
				(@ItemCode = @LogisticCarrierCode AND
				@Quantity = 1))
			BEGIN
				--Only when the current product is a logistic carrier and 
				--the quantity of the logistic carrier is 1, we can keep the product batch and best before date.
				--In all other cases, we need to remove the product
				IF(NOT(@ItemCode = @LogisticCarrierCode AND
					@Quantity = 1))
				BEGIN
					IF(@BatchNumber <> @returnBatchNumber) SET @returnBatchNumber = NULL
					IF(@BestBeforeDate <> @returnBestBeforeDate) SET @returnBestBeforeDate = NULL
				END
				
				IF(@returnQuantity IS NOT NULL)
				BEGIN
					--if we can add quantity, we check if the product is the logistic carrier.
					--if so, we add the new quantity, but we deduct 1 from the quantity because we don't count the logistic carrier
					IF(@ItemCode = @LogisticCarrierCode) SET @returnQuantity = @returnQuantity + (@Quantity - 1)
					ELSE SET @returnQuantity = @returnQuantity + @Quantity
				END
			END
			ELSE
			BEGIN
				SET @returnItemCode = NULL
				SET @returnGTIN = NULL
				SET @returnProductDescription = NULL
				SET @returnQuantity = NULL
				SET @returnBatchNumber = NULL
				SET @returnBestBeforeDate = NULL
				SET @returnBarcodeType = NULL
			END

			FETCH NEXT FROM productsCursor INTO @SSCC, @GTIN, @LogisticCarrierCode, @ItemCode, @ProductDescription, @Quantity , @IsLogisticCarrier, @BatchNumber, @BestBeforeDate, @BarcodeType,@PackagingType,@QtyPerPackagingType
		END

		CLOSE productsCursor 
		DEALLOCATE productsCursor


		--Set the barcodes
		SET @returnSSCCBarcode = dbo.PMX_FN_GenerateGS1Barcode( @returnSSCC, NULL, NULL, NULL, NULL, NULL, NULL,'' )
		SET @returnSSCCBarcodeDigit = dbo.PMX_FN_GenerateGS1BarcodeDigit ( @returnSSCC, NULL, NULL, NULL, NULL, NULL, NULL )
		SET @returnGTINBarcode = dbo.PMX_FN_GenerateGS1Barcode( NULL, @returnGTIN, @returnIsLogisticUnit, @returnBarcodeType, NULL, NULL, @returnQuantity, '')
		SET @returnGTINBarcodeDigit = dbo.PMX_FN_GenerateGS1BarcodeDigit ( NULL , @returnGTIN, @returnIsLogisticUnit, @returnBarcodeType, NULL, NULL, @returnQuantity)
		SET @returnBatchBarcode = dbo.PMX_FN_GenerateGS1Barcode( NULL, NULL, NULL, NULL, @returnBestBeforeDate, @returnBatchNumber, NULL, '')
		SET @returnBatchBarcodeDigit = dbo.PMX_FN_GenerateGS1BarcodeDigit ( NULL , NULL, NULL, NULL, @returnBestBeforeDate, @returnBatchNumber, NULL)


		IF(@returnIsLogisticUnit = 'Y') SET @returnGTINLabel = 'GTIN'
		ELSE SET @returnGTINLabel = 'CONTENT'


		DECLARE poCursor CURSOR FOR SELECT
			PONumber,
			SupplierName,
			SupplierAddress,
			ReceptionDate,
			CustomerCode,
			SONumber
		FROM dbo.PMX_IMP_DELIVERY_INFO_LABEL
		WHERE LogUnitIdentKey = @luid
		ORDER BY PONumber DESC

		OPEN poCursor
		FETCH NEXT FROM poCursor INTO @PONumber, @SupplierName, @SupplierAddress, @ReceptionDate,@CustomerCode, @SONumber

		CLOSE poCursor 
		DEALLOCATE poCursor

	END
	ELSE
	
	BEGIN
		
		
		
		DECLARE PackagingTypeCursor CURSOR FOR SELECT  PackagingTypeCode,QtyPerPackagingType  FROM PMX_IMP_SSCC_GOODSRECEIPT_LABEL
		WHERE SSCC=@SSCC
		OPEN PackagingTypeCursor
		FETCH NEXT FROM PackagingTypeCursor INTO @PackagingType,@QtyPerPackagingType
		CLOSE PackagingTypeCursor
		DEALLOCATE PackagingTypeCursor
		
		
		
		SELECT @ImpCode=U_OrgArt FROM OITM
		WHERE itemcode = @itemcode
		
		
		
		SET @returnSSCC = @SSCC
		SET @returnItemCode = @ItemCode
		SET @returnQuantity = @Quantity
		SET @returnBatchNumber = @BatchNumber
		SET @returnBestBeforeDate = @BestBeforeDate
		SET @returnPackagingType = @PackagingType
		SET @returnQtyPerPackagingType = @QtyPerPackagingType
		SET @returnImpCode= @ImpCode
		SET @ReceptionDate = Getdate()
		





		--Purchase info
		DECLARE poCursor CURSOR FOR SELECT
			OPOR.DocNum,
			OPOR.CardName,
			OPOR.[Address],
			ORDR.CardCode,
			ORDR.Docnum
		FROM dbo.OPOR
		inner JOIN dbo.POR1 ON OPOR.DocEntry = POR1.DocEntry
		LEFT OUTER JOIN RDR1 ON dbo.POR1.BaseEntry = RDR1.DocEntry and POR1.BaseLine = RDR1.lineNum
		INNER JOIN ORDR ON  RDR1.DocEntry = ORDR.DocEntry
		WHERE OPOR.DocEntry = @purchaseOrderDocEntry
		ORDER BY OPOR.DocNum DESC

		OPEN poCursor
		FETCH NEXT FROM poCursor INTO @PONumber, @SupplierName, @SupplierAddress,@CustomerCode,@SONumber

		CLOSE poCursor 
		DEALLOCATE poCursor

		SELECT @returnIsLogisticUnit = OITM.U_PMX_LOUN, @returnBarcodeType = ISNULL(U_PMX_BCTY,'G'), @returnGTIN = CodeBars, @returnProductDescription = ItemName FROM OITM WHERE OITM.ItemCode = @itemCode

		IF(@returnIsLogisticUnit = 'Y') SET @returnGTINLabel = 'GTIN'
		ELSE SET @returnGTINLabel = 'CONTENT'

		--Set the barcodes
		SET @returnSSCCBarcode = dbo.PMX_FN_GenerateGS1Barcode( @returnSSCC, NULL, NULL, NULL, NULL, NULL, NULL,'' )
		SET @returnSSCCBarcodeDigit = dbo.PMX_FN_GenerateGS1BarcodeDigit ( @returnSSCC, NULL, NULL, NULL, NULL, NULL, NULL )
		SET @returnGTINBarcode = dbo.PMX_FN_GenerateGS1Barcode( NULL, @returnGTIN, @returnIsLogisticUnit, @returnBarcodeType, NULL, NULL, @returnQuantity, '')
		SET @returnGTINBarcodeDigit = dbo.PMX_FN_GenerateGS1BarcodeDigit ( NULL , @returnGTIN, @returnIsLogisticUnit, @returnBarcodeType, NULL, NULL, @returnQuantity)
		SET @returnBatchBarcode = dbo.PMX_FN_GenerateGS1Barcode( NULL, NULL, NULL, NULL, @returnBestBeforeDate, @returnBatchNumber, NULL, '')
		SET @returnBatchBarcodeDigit = dbo.PMX_FN_GenerateGS1BarcodeDigit ( NULL , NULL, NULL, NULL, @returnBestBeforeDate, @returnBatchNumber, NULL)




	END


	--Return the values
	SELECT	@returnSSCC AS SSCC, 	
			ISNULL(@returnGTIN,'N/A') AS GTIN,
			ISNULL(@returnProductDescription,'N/A') AS ProductDescription, 
			ISNULL(CAST (@returnQuantity AS nvarchar),'N/A') Quantity,
			ISNULL(@returnBatchNumber,'N/A') AS BatchNumber, 
		--	ISNULL( CONVERT(nvarchar, @returnBestBeforeDate, 103),'N/A')  AS BestBeforeDate,
			@returnSSCCBarcode AS SSCCBarcode,
			@returnSSCCBarcodeDigit AS SSCCBarcodeDigit,
			@returnGTINBarcode AS GTINBarcode,
			@returnGTINBarcodeDigit AS GTINBarcodeDigit,
			@returnBatchBarcode AS BatchBarcode,
			@returnBatchBarcodeDigit AS BatchBarcodeDigit,
			ISNULL( CAST( @PONumber AS nvarchar),'N/A') AS PONumber,
			ISNULL(@SupplierName,'N/A') AS SupplierName,
			ISNULL(@SupplierAddress,'N/A') AS SupplierAddress,
			ISNULL( CONVERT(nvarchar, @ReceptionDate, 103),'N/A') AS ReceptionDate,
			@returnGTINLabel AS GTINLabel,
			ISNULL(@returnImpCode,'N/A') AS IMPERMO_Code,
			@returnPackagingType AS PackagingTypeCode,
			@returnQtyPerPackagingType AS QtyPerPackagingType,
			@returnQuantity As QuantityNumeric,
			@CustomerCode AS CustomerName,
			ISNULL(CAST (@SONumber AS nvarchar),'N/A') AS SONumber
		
	
END

